%define ver     3.11
%define rev     0

# Use included dependency generator
%define _use_internal_dependency_generator 0
%define __find_provides %{SOURCE10} -f %{buildroot}%{_bindir}/ocamlobjinfo
%define __find_requires %{SOURCE11} -c -f %{buildroot}%{_bindir}/ocamlobjinfo


Summary:        The Objective Caml compiler and programming environment
Name:           ocaml
Version:        %{ver}.%{rev}
Release:        1%{?dist}%{?pext}
License:        QPL/LGPL
Group:          Development/Languages
Source0:        http://caml.inria.fr/pub/distrib/%{name}-%{ver}/%{name}-%{version}.tar.bz2
Source1:        http://caml.inria.fr/pub/distrib/%{name}-%{ver}/%{name}-%{ver}-refman.html.tar.gz
Source2:        http://caml.inria.fr/pub/distrib/%{name}-%{ver}/%{name}-%{ver}-refman.pdf
Source3:        http://caml.inria.fr/pub/distrib/%{name}-%{ver}/%{name}-%{ver}-refman.txt
Source10:       %{name}-find-provides.sh
Source11:       %{name}-find-requires.sh
Patch0:         %{name}-3.11.0-build.patch
Patch1:         %{name}-3.11.0-install.patch
URL:            http://caml.inria.fr/
Buildroot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:         The Caml Team <caml@inria.fr>
Provides:       %{name}(compiler) = %{version}
Requires:       gcc gdbm-devel ncurses-devel
BuildRequires:  emacs gdbm-devel libX11-devel
BuildRequires:  ncurses-devel tcl-devel tk-devel

%description
Objective Caml is a high-level, strongly-typed, functional and object-
oriented programming language from the ML language family. This package
comprises two batch compilers (a fast bytecode compiler and an optimizing
native-code compiler), an interactive toplevel system, parsing tools (Lex,
Yacc, Camlp4), a replay debugger, a documentation generator and a compre-
hensive library.


%package        camlp4
Summary:        The Pre-Processor-Pretty-Printer for Objective Caml
Group:          Development/Languages
Requires:       %{name}-runtime = %{version}-%{release}

%description    camlp4
Camlp4 is the Pre-Processor-Pretty-Printer for Objective Caml, parsing
a source file and printing some result on standard output. This package
contains the runtime files.


%package        camlp4-devel
Summary:        The Pre-Processor-Pretty-Printer for Objective Caml
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-camlp4 = %{version}-%{release}

%description    camlp4-devel
Camlp4 is the Pre-Processor-Pretty-Printer for Objective Caml, parsing
a source file and printing some result on standard output. This package
contains the development files.


%package        doc
Summary:        Documentation for Objective Caml
Group:          Documentation
Requires:       %{name} = %{version}-%{release}

%description    doc
Objective Caml is a high-level, strongly-typed, functional and object-
oriented programming language from the ML language family. This package
contains documentation in PDF and HTML format as well as the development
man pages.


%package        emacs
Summary:        Emacs mode for Objective Caml
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}
Requires:       emacs

%description    emacs
Objective Caml is a high-level, strongly-typed, functional and object-
oriented programming language from the ML language family. This package
provides the Emacs mode for Objective Caml.


%package        labltk
Summary:        Tk bindings for Objective Caml
Group:          System Environment/Libraries
Requires:       %{name}-runtime = %{version}-%{release}

%description    labltk
Labltk is a library for interfacing Objective Caml with the scripting
language Tcl/Tk. This package contains the runtime files.


%package        labltk-devel
Summary:        Development files for labltk
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-labltk = %{version}-%{release}
Requires:       libX11-devel

%description    labltk-devel
Labltk is a library for interfacing Objective Caml with the scripting
language Tcl/Tk. This package contains the development files as well
as the OCaml browser for code editing and library browsing.


%package        ocamldoc
Summary:        The documentation generator for Objective Caml
Group:          Development/Languages
Provides:       ocamldoc
Requires:       %{name} = %{version}-%{release}

%description    ocamldoc
Objective Caml is a high-level, strongly-typed, functional and object-
oriented programming language from the ML language family. This package
contains the documentation generator for Objective Caml.


%package        runtime
Summary:        The Objective Caml runtime environment
Group:          System Environment/Libraries
Provides:       %{name}(runtime) = %{version}

%description    runtime
Objective Caml is a high-level, strongly-typed, functional and object-
oriented programming language from the ML language family. This package
contains the runtime environment needed to run Objective Caml bytecode.


%package        source
Summary:        Source code for Objective Caml libraries
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}

%description    source
Objective Caml is a high-level, strongly-typed, functional and object-
oriented programming language from the ML language family. This package
contains the source code for Objective Caml libraries.


%package        x11
Summary:        X11 support for Objective Caml
Group:          System Environment/Libraries
Requires:       %{name}-runtime = %{version}-%{release}
Requires:       libX11-devel

%description    x11
Objective Caml is a high-level, strongly-typed, functional and object-
oriented programming language from the ML language family. This package
provides X11 support for Objective Caml.


%prep
%setup -q -a 1
%patch0 -p1
%patch1 -p1

# Prepare docs
%{__cp} %{SOURCE2} refman.pdf
%{__cp} %{SOURCE3} refman.txt


%build
CFLAGS="${RPM_OPT_FLAGS} -fno-strict-aliasing" \
	./configure                            \
	-prefix %{_prefix}                     \
	-libdir %{_libdir}/%{name}             \
	-mandir %{_mandir}/man1                \
	-x11include %{_includedir}             \
	-x11lib %{_libdir}                     \
	-with-pthread

%{__make} \
	world opt opt.opt

# Build Emacs files
pushd emacs
%{__make} \
	ocamltags
popd

# Build objinfo
pushd tools
../boot/ocamlrun ../ocamlopt -nostdlib            \
	-I ../stdlib -I ../utils -I ../parsing    \
	-I ../typing -I ../bytecomp -I ../asmcomp \
	-I ../driver -o objinfo config.cmx objinfo.ml
popd


%check
%{__make} bootstrap


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_prefix}/lib/rpm
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_datadir}/emacs/site-lisp

%{__make} \
	BINDIR=${RPM_BUILD_ROOT}%{_bindir}         \
	LIBDIR=${RPM_BUILD_ROOT}%{_libdir}/%{name} \
	MANDIR=${RPM_BUILD_ROOT}%{_mandir}         \
	install

echo "%{version}" >${RPM_BUILD_ROOT}%{_libdir}/%{name}/fedora-%{name}-release

# Fix library path
%{__perl} -i -pe "s+^${RPM_BUILD_ROOT}++" ${RPM_BUILD_ROOT}%{_libdir}/%{name}/ld.conf

# Install Emacs files
pushd emacs
%{__make} \
	BINDIR=${RPM_BUILD_ROOT}%{_bindir}         \
	EMACSDIR=${RPM_BUILD_ROOT}%{_datadir}/emacs/site-lisp \
	install

%{__make} \
	BINDIR=${RPM_BUILD_ROOT}%{_bindir}         \
	install-ocamltags
popd

# Install objinfo
%{__install} -m 0755 tools/objinfo ${RPM_BUILD_ROOT}%{_bindir}/ocamlobjinfo

# Install rpmbuild helper files
%{__install} -m 0755 %{SOURCE10}   ${RPM_BUILD_ROOT}%{_prefix}/lib/rpm
%{__install} -m 0755 %{SOURCE11}   ${RPM_BUILD_ROOT}%{_prefix}/lib/rpm


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc Changes INSTALL LICENSE README Upgrading VERSION
%{_bindir}/%{name}
%{_bindir}/ocamlbuild
%{_bindir}/ocamlbuild.byte
%{_bindir}/ocamlbuild.native
%{_bindir}/ocamlc
%{_bindir}/ocamlc.opt
%{_bindir}/ocamlcp
%{_bindir}/ocamldebug
%{_bindir}/ocamldep
%{_bindir}/ocamldep.opt
%{_bindir}/ocamllex
%{_bindir}/ocamllex.opt
%{_bindir}/ocamlmklib
%{_bindir}/ocamlmktop
%{_bindir}/ocamlobjinfo
%{_bindir}/ocamlopt
%{_bindir}/ocamlopt.opt
%{_bindir}/ocamlprof
%{_bindir}/ocamlyacc
%{_libdir}/%{name}/addlabels
%{_libdir}/%{name}/scrapelabels
%{_libdir}/%{name}/camlheader
%{_libdir}/%{name}/camlheader_ur
%{_libdir}/%{name}/expunge
%{_libdir}/%{name}/extract_crc
%{_libdir}/%{name}/ld.conf
%{_libdir}/%{name}/Makefile.config
%{_libdir}/%{name}/*.a
%{_libdir}/%{name}/*.cmxa
%{_libdir}/%{name}/*.cmxs
%{_libdir}/%{name}/*.cmx
%{_libdir}/%{name}/*.mli
%{_libdir}/%{name}/*.o
%{_libdir}/%{name}/libcamlrun_shared.so
%{_libdir}/%{name}/vmthreads/*.mli
%{_libdir}/%{name}/vmthreads/*.a
%{_libdir}/%{name}/threads/*.a
%{_libdir}/%{name}/threads/*.cmxa
%{_libdir}/%{name}/threads/*.cmx
%{_libdir}/%{name}/caml
%{_libdir}/%{name}/ocamlbuild
%exclude %{_libdir}/%{name}/graphicsX11.mli

%files camlp4
%defattr(-,root,root)
%dir %{_libdir}/%{name}/camlp4
%{_libdir}/%{name}/camlp4/*.cmi
%{_libdir}/%{name}/camlp4/*.cma
%{_libdir}/%{name}/camlp4/*.cmo
%dir %{_libdir}/%{name}/camlp4/Camlp4Filters
%{_libdir}/%{name}/camlp4/Camlp4Filters/*.cmi
%{_libdir}/%{name}/camlp4/Camlp4Filters/*.cmo
%dir %{_libdir}/%{name}/camlp4/Camlp4Parsers
%{_libdir}/%{name}/camlp4/Camlp4Parsers/*.cmo
%{_libdir}/%{name}/camlp4/Camlp4Parsers/*.cmi
%dir %{_libdir}/%{name}/camlp4/Camlp4Printers
%{_libdir}/%{name}/camlp4/Camlp4Printers/*.cmi
%{_libdir}/%{name}/camlp4/Camlp4Printers/*.cmo
%dir %{_libdir}/%{name}/camlp4/Camlp4Top
%{_libdir}/%{name}/camlp4/Camlp4Top/*.cmi
%{_libdir}/%{name}/camlp4/Camlp4Top/*.cmo

%files camlp4-devel
%defattr(-,root,root)
%{_bindir}/camlp4*
%{_bindir}/mkcamlp4
%{_libdir}/%{name}/camlp4/*.a
%{_libdir}/%{name}/camlp4/*.cmxa
%{_libdir}/%{name}/camlp4/*.cmx
%{_libdir}/%{name}/camlp4/*.o
%{_libdir}/%{name}/camlp4/Camlp4Filters/*.cmx
%{_libdir}/%{name}/camlp4/Camlp4Filters/*.o
%{_libdir}/%{name}/camlp4/Camlp4Parsers/*.cmx
%{_libdir}/%{name}/camlp4/Camlp4Parsers/*.o
%{_libdir}/%{name}/camlp4/Camlp4Printers/*.cmx
%{_libdir}/%{name}/camlp4/Camlp4Printers/*.o
%{_libdir}/%{name}/camlp4/Camlp4Top/*.cmx
%{_libdir}/%{name}/camlp4/Camlp4Top/*.o
%{_mandir}/man1/*.1*

%files doc
%defattr(-,root,root)
%doc htmlman refman.{pdf,txt}
%{_mandir}/man3/*.3*

%files emacs
%defattr(-,root,root)
%doc emacs/README
%{_bindir}/ocamltags
%{_datadir}/emacs/site-lisp/*

%files labltk
%defattr(-,root,root)
%{_bindir}/labltk
%dir %{_libdir}/%{name}/labltk
%{_libdir}/%{name}/labltk/*.cmi
%{_libdir}/%{name}/labltk/*.cma
%{_libdir}/%{name}/labltk/*.cmo
%{_libdir}/%{name}/stublibs/dlllabltk.so
%{_libdir}/%{name}/stublibs/dlltkanim.so

%files labltk-devel
%defattr(-,root,root)
%doc otherlibs/labltk/examples_labltk
%doc otherlibs/labltk/examples_camltk
%{_bindir}/ocamlbrowser
%{_libdir}/%{name}/labltk/labltktop
%{_libdir}/%{name}/labltk/pp
%{_libdir}/%{name}/labltk/tkcompiler
%{_libdir}/%{name}/labltk/*.a
%{_libdir}/%{name}/labltk/*.cmxa
%{_libdir}/%{name}/labltk/*.cmx
%{_libdir}/%{name}/labltk/*.mli
%{_libdir}/%{name}/labltk/*.o

%files ocamldoc
%defattr(-,root,root)
%doc ocamldoc/Changes.txt
%{_bindir}/ocamldoc*
%{_libdir}/%{name}/ocamldoc

%files runtime
%defattr(-,root,root)
%doc Changes INSTALL LICENSE README Upgrading VERSION
%{_bindir}/ocamlrun
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/*.cmo
%{_libdir}/%{name}/*.cmi
%{_libdir}/%{name}/*.cma
%{_libdir}/%{name}/stublibs
%dir %{_libdir}/%{name}/vmthreads
%{_libdir}/%{name}/vmthreads/*.cmi
%{_libdir}/%{name}/vmthreads/*.cma
%dir %{_libdir}/%{name}/threads
%{_libdir}/%{name}/threads/*.cmi
%{_libdir}/%{name}/threads/*.cma
%{_libdir}/%{name}/fedora-ocaml-release
%{_prefix}/lib/rpm/%{name}-find-provides.sh
%{_prefix}/lib/rpm/%{name}-find-requires.sh
%exclude %{_libdir}/%{name}/graphicsX11.cmi
%exclude %{_libdir}/%{name}/stublibs/dllgraphics.so
%exclude %{_libdir}/%{name}/stublibs/dlllabltk.so
%exclude %{_libdir}/%{name}/stublibs/dlltkanim.so

%files source
%defattr(-,root,root)
%{_libdir}/%{name}/*.ml

%files x11
%defattr(-,root,root)
%{_libdir}/%{name}/graphicsX11.cmi
%{_libdir}/%{name}/graphicsX11.mli
%{_libdir}/%{name}/stublibs/dllgraphics.so


%changelog
* Tue Mar 24 2009 Peter Pramberger <peterpramb@member.fsf.org> - 3.11.0-1
- Initial build
